//Date in logs
//Copyright (C) 2010 Zlyden'
//http://jass.ucoz.net/
//
//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//Created by:
//       Zlyden' <zlyden007@mail.ru>

/* v 1.0 06.07.2010 19:00:59 Zlyden' */

#include "version.h"
#include "main.h"
//#include <io.h>
#include <jka/game/q_shared.h>
#include <jka/game/g_local.h>
#include <jassapi.h>
#include <time.h>

pluginres_t* g_result = NULL;
plugininfo_t g_plugininfo = {
	"Date-in-logs",
	Date_in_logs_VERSION,
	"Adds a date of event in gamelogs",
	Date_in_logs_BUILDER,
	"http://jass.ucoz.net/",
	1,
	1,
	1,
	JASS_PIFV_MAJOR,
	JASS_PIFV_MINOR
};
eng_syscall_t g_syscall = NULL;
mod_vmMain_t g_vmMain = NULL;
pluginfuncs_t* g_pluginfuncs = NULL;
time_t ltime_global=0;

int log_write(const char* text) {
	if (text && *text) {
		return JASS_WRITEGAMELOG(text);
	}
	return -1;
}

C_DLLEXPORT void JASS_Query(plugininfo_t** pinfo) {
	*pinfo = &g_plugininfo;
}

C_DLLEXPORT int JASS_Attach(eng_syscall_t engfunc, mod_vmMain_t modfunc, pluginres_t* presult, pluginfuncs_t* pluginfuncs, int iscmd) {
	g_syscall = engfunc;
	g_vmMain = modfunc;
	g_result = presult;
	g_pluginfuncs = pluginfuncs;
	//g_syscall(G_PRINT, JASS_VARARGS("%s v.%s by %s started\n", g_plugininfo.name, g_plugininfo.version, g_plugininfo.author));

	iscmd = 0;

	return 1;
}

C_DLLEXPORT void JASS_Detach(int iscmd) {
	iscmd = 0;
}

C_DLLEXPORT int JASS_vmMain(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11){
	JASS_RET_IGNORED(1);
}

C_DLLEXPORT int JASS_syscall(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11, int arg12){

	if (cmd==G_FS_WRITE&&arg2==JASS_GETLOGHANDLE()){
		time_t ltime;
		time(&ltime);
		char *date=ctime(&ltime);
		date[24]=':';
		if (ltime!=ltime_global){
			log_write(date);
			ltime_global=ltime;
		}
	}
	JASS_RET_IGNORED(1);
}

C_DLLEXPORT int JASS_vmMain_Post(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11)
{
	JASS_RET_IGNORED(1);
}

C_DLLEXPORT int JASS_syscall_Post(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11, int arg12) {
	JASS_RET_IGNORED(1);
}
